package cn.iocoder.yudao.module.rescue.utils;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import org.apache.commons.lang3.time.DateFormatUtils;

import java.lang.management.ManagementFactory;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.*;
import java.util.*;

/**
 * 时间工具类
 *
 * @author ruoyi
 */
public class DateUtils extends org.apache.commons.lang3.time.DateUtils
{
    public static String YYYY = "yyyy";

    public static String YYYY_MM = "yyyy-MM";

    public static String YYYY_MM_DD = "yyyy-MM-dd";

    public static String YYYYMMDDHHMMSS = "yyyyMMddHHmmss";

    public static String YYYY_MM_DD_HH_MM_SS = "yyyy-MM-dd HH:mm:ss";

    private static String[] parsePatterns = {
            "yyyy-MM-dd", "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm", "yyyy-MM",
            "yyyy/MM/dd", "yyyy/MM/dd HH:mm:ss", "yyyy/MM/dd HH:mm", "yyyy/MM",
            "yyyy.MM.dd", "yyyy.MM.dd HH:mm:ss", "yyyy.MM.dd HH:mm", "yyyy.MM"};

    /**
     * 获取当前Date型日期
     *
     * @return Date() 当前日期
     */
    public static Date getNowDate()
    {
        return new Date();
    }

    /**
     * 获取当前日期, 默认格式为yyyy-MM-dd
     *
     * @return String
     */
    public static String getDate()
    {
        return dateTimeNow(YYYY_MM_DD);
    }

    public static final String getTime()
    {
        return dateTimeNow(YYYY_MM_DD_HH_MM_SS);
    }

    public static final String dateTimeNow()
    {
        return dateTimeNow(YYYYMMDDHHMMSS);
    }

    public static final String dateTimeNow(final String format)
    {
        return parseDateToStr(format, new Date());
    }

    public static final String dateTime(final Date date)
    {
        return parseDateToStr(YYYY_MM_DD, date);
    }

    public static final String parseDateToStr(final String format, final Date date)
    {
        return new SimpleDateFormat(format).format(date);
    }

    public static final Date dateTime(final String format, final String ts)
    {
        try
        {
            return new SimpleDateFormat(format).parse(ts);
        }
        catch (ParseException e)
        {
            throw new RuntimeException(e);
        }
    }

    /**
     * 日期路径 即年/月/日 如2018/08/08
     */
    public static final String datePath()
    {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyy/MM/dd");
    }

    /**
     * 日期路径 即年/月/日 如20180808
     */
    public static final String dateTime()
    {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyyMMdd");
    }

    /**
     * 日期型字符串转化为日期 格式
     */
    public static Date parseDate(Object str)
    {
        if (str == null)
        {
            return null;
        }
        try
        {
            return parseDate(str.toString(), parsePatterns);
        }
        catch (ParseException e)
        {
            return null;
        }
    }

    /**
     * 获取服务器启动时间
     */
    public static Date getServerStartDate()
    {
        long time = ManagementFactory.getRuntimeMXBean().getStartTime();
        return new Date(time);
    }

    /**
     * 计算相差天数
     */
    public static int differentDaysByMillisecond(Date date1, Date date2)
    {
        return Math.abs((int) ((date2.getTime() - date1.getTime()) / (1000 * 3600 * 24)));
    }

    /**
     * 计算时间差
     *
     * @param endDate 最后时间
     * @param startTime 开始时间
     * @return 时间差（天/小时/分钟）
     */
    public static String timeDistance(Date endDate, Date startTime)
    {
        long nd = 1000 * 24 * 60 * 60;
        long nh = 1000 * 60 * 60;
        long nm = 1000 * 60;
        // long ns = 1000;
        // 获得两个时间的毫秒时间差异
        long diff = endDate.getTime() - startTime.getTime();
        // 计算差多少天
        long day = diff / nd;
        // 计算差多少小时
        long hour = diff % nd / nh;
        // 计算差多少分钟
        long min = diff % nd % nh / nm;
        // 计算差多少秒//输出结果
        // long sec = diff % nd % nh % nm / ns;
        return day + "天" + hour + "小时" + min + "分钟";
    }

    /**
     * 增加 LocalDateTime ==> Date
     */
    public static Date toDate(LocalDateTime temporalAccessor)
    {
        ZonedDateTime zdt = temporalAccessor.atZone(ZoneId.systemDefault());
        return Date.from(zdt.toInstant());
    }

    /**
     * 增加 LocalDate ==> Date
     */
    public static Date toDate(LocalDate temporalAccessor)
    {
        LocalDateTime localDateTime = LocalDateTime.of(temporalAccessor, LocalTime.of(0, 0, 0));
        ZonedDateTime zdt = localDateTime.atZone(ZoneId.systemDefault());
        return Date.from(zdt.toInstant());
    }

    /**
     * 通过时间类型、开始时间计算结束时间
     * @param timeType
     * @param startTime
     * @return
     */
    public static DateTime getEndTime(String timeType, DateTime startTime) {
        switch (timeType) {
            case "day":
                return DateUtil.endOfDay(startTime);
            case "week":
                return DateUtil.endOfWeek(startTime);
            case "month":
                return DateUtil.endOfMonth(startTime);
            case "year":
                return DateUtil.endOfYear(startTime);
            case "recentYear":
                return DateUtil.endOfYear(startTime);
            case "recentMonth":
                return DateUtil.endOfMonth(startTime);
            case "recentQuarter":
                DateTime endOfQuarter = DateUtil.offsetMonth(startTime, 3);
                return DateUtil.endOfDay(DateUtil.offsetDay(endOfQuarter, -1));
            default:
                return null;
        }
    }


    /**
     * 获取时间名称（根据时间类型）
     * @param timeType
     * @param dateTime
     * @return
     */
    public static String getDateName(String timeType, DateTime dateTime) {
        String name = "";
        switch (timeType) {
            case "day":
                name = dateTime.toString("HH:mm");
                break;
            case "month":
            case "week":
            case "recentMonth":
                name = dateTime.toString("MM-dd");
                break;
            case "year":
            case "recentYear":
            case "recentQuarter":
                name = dateTime.toString("YYYY-MM");
                break;
        }
        return name;
    }

    /**
     * 获取时间列表（根据时间类型）
     * @param timeType
     * @return
     */
    public static Map<String, Object> getDateTimeList(String timeType) {
        Map<String, Object> result = new HashMap<>();
        DateTime now = DateUtil.date();
        DateTime startTime = now;
        DateTime endTime = now;
        List<DateTime> dateList = new ArrayList<>();

        switch (timeType) {
            case "day":
                startTime = DateUtil.beginOfDay(startTime);
                endTime = DateUtil.endOfDay(endTime);
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.HOUR_OF_DAY);
                break;
            case "week":
                startTime = DateUtil.beginOfWeek(startTime);
                endTime = DateUtil.endOfWeek(endTime);
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.DAY_OF_WEEK);
                break;
            case "month":
                startTime = DateUtil.beginOfMonth(startTime);
                endTime = DateUtil.endOfMonth(endTime);
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.DAY_OF_MONTH);
                break;
            case "year":
                startTime = DateUtil.beginOfYear(startTime);
                endTime = DateUtil.endOfYear(endTime);
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.MONTH);
                break;
            case "recentYear":
                startTime = DateUtil.offsetYear(now, -1);
                endTime = now;
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.MONTH);
                break;
            case "recentMonth":
                startTime = DateUtil.offsetMonth(now, -1);
                endTime = now;
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.DAY_OF_MONTH);
                break;
            case "recentQuarter":
                startTime = DateUtil.offsetMonth(now, -3);
                endTime = now;
                dateList = DateUtil.rangeToList(startTime, endTime, DateField.MONTH);
                break;
        }

        result.put("dateList", dateList);
        result.put("startTime", startTime);
        result.put("endTime", endTime);
        return result;
    }
}
